/*
 *  rommon Simple Monitor
 * 
 *  Copyright (C) 1999-2004 by Dep. of Computer Science and Engineering
 *                   Tomakomai National College of Technology, JAPAN
 *  Copyright (C) 2006 by GJ Business Division RICOH COMPANY,LTD. JAPAN
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: $
 */

/*
 *	3069.S -- depend H8/3069F
 */

#define _MACRO_ONLY
#include "sys_defs.h"
#include "mondefs.h"
#include "serial.h"

		.h8300h

		.text
		.align		2
		.globl		_Main
		.globl		_Disable
		.globl		_Enable
		.globl		_SetVector
		.globl		_sil_dly_nse

/*
 *  Reset Program
 */
_Main:
		mov.l	#STACK_TOP, sp
		bsr		_MonMain:16
MainLoop:
		bra		MainLoop

/*
 *  interrupt disable
 */
_Disable:
		orc.b		#CCR_INTERRUPT, ccr		/* disable interrupt on CCR */
		rts
/*
 *  interrupt enable
 */
_Enable:
		andc.b		#(~CCR_INTERRUPT & 0xFF), ccr		/* enable interrupt on CCR */
		rts

/*
 *  set vector
 */
_SetVector:
		mov.l		er0, @CurrentVector
		rts

/*
 * եȥǥ쥣ؿ
 */
_sil_dly_nse:
	shlr.l	er0
_sil_dly_loop:
	dec.l	#1,er0
	bne		_sil_dly_loop
	rts

/*
 *	SCI Intrrupt Handler: SCI #0, Error
 */

_InterERI0:
		rte

/*
 *	SCI Intrrupt Handler: SCI #0, Recive Data Full
 */

_InterRXI0:
		push.l		er0
		push.l		er1
		push.l		er2
		push.l		er3
		sub.l		er0, er0
		bsr		_ComInterRX:16
		pop.l		er3
		pop.l		er2
		pop.l		er1
		pop.l		er0
		rte

/*
 *	SCI Intrrupt Handler: SCI #0, Transmit Data Empty
 */

_InterTXI0:
		push.l		er0
		push.l		er1
		push.l		er2
		push.l		er3
		sub.l		er0, er0
		bsr		_ComInterTX:16
		pop.l		er3
		pop.l		er2
		pop.l		er1
		pop.l		er0
		rte

/*
 *	SCI Intrrupt Handler: SCI #0, Transmit Data End
 */

_InterTEI0:
		rte

#if MAX_SERIAL >= 2

/*
 *	SCI Intrrupt Handler: SCI #1, Error
 */

_InterERI1:
		rte

/*
 *	SCI Intrrupt Handler: SCI #1, Recive Data Full
 */

_InterRXI1:
		push.l		er0
		push.l		er1
		push.l		er2
		push.l		er3
		sub.l		er0, er0
		inc.l		#1, er0
		bsr		_ComInterRX:16
		pop.l		er3
		pop.l		er2
		pop.l		er1
		pop.l		er0
		rte

/*
 *	SCI Intrrupt Handler: SCI #1, Transmit Data Empty
 */

_InterTXI1:
		push.l		er0
		push.l		er1
		push.l		er2
		push.l		er3
		sub.l		er0, er0
		inc.l		#1, er0
		bsr		_ComInterTX:16
		pop.l		er3
		pop.l		er2
		pop.l		er1
		pop.l		er0
		rte

/*
 *	SCI Intrrupt Handler: SCI #1, Transmit Data End
 */

_InterTEI1:
		rte

#endif	/* of #if MAX_SERIAL >= 2 */

#if MAX_SERIAL >= 3

/*
 *	SCI Intrrupt Handler: SCI #2, Error
 */

_InterERI2:
		rte

/*
 *	SCI Intrrupt Handler: SCI #2, Recive Data Full
 */

_InterRXI2:
		push.l		er0
		push.l		er1
		push.l		er2
		push.l		er3
		sub.l		er0, er0
		inc.l		#2, er0
		bsr		_ComInterRX:16
		pop.l		er3
		pop.l		er2
		pop.l		er1
		pop.l		er0
		rte

/*
 *	SCI Intrrupt Handler: SCI #2, Transmit Data Empty
 */

_InterTXI2:
		push.l		er0
		push.l		er1
		push.l		er2
		push.l		er3
		sub.l		er0, er0
		inc.l		#2, er0
		bsr		_ComInterTX:16
		pop.l		er3
		pop.l		er2
		pop.l		er1
		pop.l		er0
		rte

/*
 *	SCI Intrrupt Handler: SCI #2, Transmit Data End
 */

_InterTEI2:
		rte

#endif	/* of #if MAX_SERIAL >= 3 */

/*
 *	Interrupt Entry
 */

		.text
		.align		2

_IntEntry0x04:
		subs		#2, sp
		stc.w		ccr, @-er7
		push.l		er0
		push.l		er1
		mov.l		@CurrentVector, er0
		mov.b		#0x04, r0l
		mov.l		@er0, er1
		beq		IntError:16
		mov.w		r1, @(10, sp)
		mov.w		e1, r1
		mov.b		r1l, @(9, sp)
		pop.l		er1
		pop.l		er0
		rte

_IntEntry0x08:
		subs		#2, sp
		stc.w		ccr, @-er7
		push.l		er0
		push.l		er1
		mov.l		@CurrentVector, er0
		mov.b		#0x08, r0l
		mov.l		@er0, er1
		beq		IntError:16
		mov.w		r1, @(10, sp)
		mov.w		e1, r1
		mov.b		r1l, @(9, sp)
		pop.l		er1
		pop.l		er0
		rte

_IntEntry0x0c:
		subs		#2, sp
		stc.w		ccr, @-er7
		push.l		er0
		push.l		er1
		mov.l		@CurrentVector, er0
		mov.b		#0x0c, r0l
		mov.l		@er0, er1
		beq		IntError:16
		mov.w		r1, @(10, sp)
		mov.w		e1, r1
		mov.b		r1l, @(9, sp)
		pop.l		er1
		pop.l		er0
		rte

_IntEntry0x10:
		subs		#2, sp
		stc.w		ccr, @-er7
		push.l		er0
		push.l		er1
		mov.l		@CurrentVector, er0
		mov.b		#0x10, r0l
		mov.l		@er0, er1
		beq		IntError:16
		mov.w		r1, @(10, sp)
		mov.w		e1, r1
		mov.b		r1l, @(9, sp)
		pop.l		er1
		pop.l		er0
		rte

_IntEntry0x14:
		subs		#2, sp
		stc.w		ccr, @-er7
		push.l		er0
		push.l		er1
		mov.l		@CurrentVector, er0
		mov.b		#0x14, r0l
		mov.l		@er0, er1
		beq		IntError:16
		mov.w		r1, @(10, sp)
		mov.w		e1, r1
		mov.b		r1l, @(9, sp)
		pop.l		er1
		pop.l		er0
		rte

_IntEntry0x18:
		subs		#2, sp
		stc.w		ccr, @-er7
		push.l		er0
		push.l		er1
		mov.l		@CurrentVector, er0
		mov.b		#0x18, r0l
		mov.l		@er0, er1
		beq		IntError:16
		mov.w		r1, @(10, sp)
		mov.w		e1, r1
		mov.b		r1l, @(9, sp)
		pop.l		er1
		pop.l		er0
		rte

_IntEntry0x1c:
		subs		#2, sp
		stc.w		ccr, @-er7
		push.l		er0
		push.l		er1
		mov.l		@CurrentVector, er0
		mov.b		#0x1c, r0l
		mov.l		@er0, er1
		beq		IntError:16
		mov.w		r1, @(10, sp)
		mov.w		e1, r1
		mov.b		r1l, @(9, sp)
		pop.l		er1
		pop.l		er0
		rte

_IntEntry0x20:
		subs		#2, sp
		stc.w		ccr, @-er7
		push.l		er0
		push.l		er1
		mov.l		@CurrentVector, er0
		mov.b		#0x20, r0l
		mov.l		@er0, er1
		beq		IntError:16
		mov.w		r1, @(10, sp)
		mov.w		e1, r1
		mov.b		r1l, @(9, sp)
		pop.l		er1
		pop.l		er0
		rte

_IntEntry0x24:
		subs		#2, sp
		stc.w		ccr, @-er7
		push.l		er0
		push.l		er1
		mov.l		@CurrentVector, er0
		mov.b		#0x24, r0l
		mov.l		@er0, er1
		beq		IntError:16
		mov.w		r1, @(10, sp)
		mov.w		e1, r1
		mov.b		r1l, @(9, sp)
		pop.l		er1
		pop.l		er0
		rte

_IntEntry0x28:
		subs		#2, sp
		stc.w		ccr, @-er7
		push.l		er0
		push.l		er1
		mov.l		@CurrentVector, er0
		mov.b		#0x28, r0l
		mov.l		@er0, er1
		beq		IntError:16
		mov.w		r1, @(10, sp)
		mov.w		e1, r1
		mov.b		r1l, @(9, sp)
		pop.l		er1
		pop.l		er0
		rte

_IntEntry0x2c:
		subs		#2, sp
		stc.w		ccr, @-er7
		push.l		er0
		push.l		er1
		mov.l		@CurrentVector, er0
		mov.b		#0x2c, r0l
		mov.l		@er0, er1
		beq		IntError:16
		mov.w		r1, @(10, sp)
		mov.w		e1, r1
		mov.b		r1l, @(9, sp)
		pop.l		er1
		pop.l		er0
		rte

_IntEntry0x30:
		subs		#2, sp
		stc.w		ccr, @-er7
		push.l		er0
		push.l		er1
		mov.l		@CurrentVector, er0
		mov.b		#0x30, r0l
		mov.l		@er0, er1
		beq		IntError:16
		mov.w		r1, @(10, sp)
		mov.w		e1, r1
		mov.b		r1l, @(9, sp)
		pop.l		er1
		pop.l		er0
		rte

_IntEntry0x34:
		subs		#2, sp
		stc.w		ccr, @-er7
		push.l		er0
		push.l		er1
		mov.l		@CurrentVector, er0
		mov.b		#0x34, r0l
		mov.l		@er0, er1
		beq		IntError:16
		mov.w		r1, @(10, sp)
		mov.w		e1, r1
		mov.b		r1l, @(9, sp)
		pop.l		er1
		pop.l		er0
		rte

_IntEntry0x38:
		subs		#2, sp
		stc.w		ccr, @-er7
		push.l		er0
		push.l		er1
		mov.l		@CurrentVector, er0
		mov.b		#0x38, r0l
		mov.l		@er0, er1
		beq		IntError:16
		mov.w		r1, @(10, sp)
		mov.w		e1, r1
		mov.b		r1l, @(9, sp)
		pop.l		er1
		pop.l		er0
		rte

_IntEntry0x3c:
		subs		#2, sp
		stc.w		ccr, @-er7
		push.l		er0
		push.l		er1
		mov.l		@CurrentVector, er0
		mov.b		#0x3c, r0l
		mov.l		@er0, er1
		beq		IntError:16
		mov.w		r1, @(10, sp)
		mov.w		e1, r1
		mov.b		r1l, @(9, sp)
		pop.l		er1
		pop.l		er0
		rte

_IntEntry0x40:
		subs		#2, sp
		stc.w		ccr, @-er7
		push.l		er0
		push.l		er1
		mov.l		@CurrentVector, er0
		mov.b		#0x40, r0l
		mov.l		@er0, er1
		beq		IntError:16
		mov.w		r1, @(10, sp)
		mov.w		e1, r1
		mov.b		r1l, @(9, sp)
		pop.l		er1
		pop.l		er0
		rte

_IntEntry0x44:
		subs		#2, sp
		stc.w		ccr, @-er7
		push.l		er0
		push.l		er1
		mov.l		@CurrentVector, er0
		mov.b		#0x44, r0l
		mov.l		@er0, er1
		beq		IntError:16
		mov.w		r1, @(10, sp)
		mov.w		e1, r1
		mov.b		r1l, @(9, sp)
		pop.l		er1
		pop.l		er0
		rte

_IntEntry0x48:
		subs		#2, sp
		stc.w		ccr, @-er7
		push.l		er0
		push.l		er1
		mov.l		@CurrentVector, er0
		mov.b		#0x48, r0l
		mov.l		@er0, er1
		beq		IntError:16
		mov.w		r1, @(10, sp)
		mov.w		e1, r1
		mov.b		r1l, @(9, sp)
		pop.l		er1
		pop.l		er0
		rte

_IntEntry0x4c:
		subs		#2, sp
		stc.w		ccr, @-er7
		push.l		er0
		push.l		er1
		mov.l		@CurrentVector, er0
		mov.b		#0x4c, r0l
		mov.l		@er0, er1
		beq		IntError:16
		mov.w		r1, @(10, sp)
		mov.w		e1, r1
		mov.b		r1l, @(9, sp)
		pop.l		er1
		pop.l		er0
		rte

_IntEntry0x50:
		subs		#2, sp
		stc.w		ccr, @-er7
		push.l		er0
		push.l		er1
		mov.l		@CurrentVector, er0
		mov.b		#0x50, r0l
		mov.l		@er0, er1
		beq		IntError:16
		mov.w		r1, @(10, sp)
		mov.w		e1, r1
		mov.b		r1l, @(9, sp)
		pop.l		er1
		pop.l		er0
		rte

_IntEntry0x54:
		subs		#2, sp
		stc.w		ccr, @-er7
		push.l		er0
		push.l		er1
		mov.l		@CurrentVector, er0
		mov.b		#0x54, r0l
		mov.l		@er0, er1
		beq		IntError:16
		mov.w		r1, @(10, sp)
		mov.w		e1, r1
		mov.b		r1l, @(9, sp)
		pop.l		er1
		pop.l		er0
		rte

_IntEntry0x58:
		subs		#2, sp
		stc.w		ccr, @-er7
		push.l		er0
		push.l		er1
		mov.l		@CurrentVector, er0
		mov.b		#0x58, r0l
		mov.l		@er0, er1
		beq		IntError:16
		mov.w		r1, @(10, sp)
		mov.w		e1, r1
		mov.b		r1l, @(9, sp)
		pop.l		er1
		pop.l		er0
		rte

_IntEntry0x5c:
		subs		#2, sp
		stc.w		ccr, @-er7
		push.l		er0
		push.l		er1
		mov.l		@CurrentVector, er0
		mov.b		#0x5c, r0l
		mov.l		@er0, er1
		beq		IntError:16
		mov.w		r1, @(10, sp)
		mov.w		e1, r1
		mov.b		r1l, @(9, sp)
		pop.l		er1
		pop.l		er0
		rte

_IntEntry0x60:
		subs		#2, sp
		stc.w		ccr, @-er7
		push.l		er0
		push.l		er1
		mov.l		@CurrentVector, er0
		mov.b		#0x60, r0l
		mov.l		@er0, er1
		beq		IntError:16
		mov.w		r1, @(10, sp)
		mov.w		e1, r1
		mov.b		r1l, @(9, sp)
		pop.l		er1
		pop.l		er0
		rte

_IntEntry0x64:
		subs		#2, sp
		stc.w		ccr, @-er7
		push.l		er0
		push.l		er1
		mov.l		@CurrentVector, er0
		mov.b		#0x64, r0l
		mov.l		@er0, er1
		beq		IntError:16
		mov.w		r1, @(10, sp)
		mov.w		e1, r1
		mov.b		r1l, @(9, sp)
		pop.l		er1
		pop.l		er0
		rte

_IntEntry0x68:
		subs		#2, sp
		stc.w		ccr, @-er7
		push.l		er0
		push.l		er1
		mov.l		@CurrentVector, er0
		mov.b		#0x68, r0l
		mov.l		@er0, er1
		beq		IntError:16
		mov.w		r1, @(10, sp)
		mov.w		e1, r1
		mov.b		r1l, @(9, sp)
		pop.l		er1
		pop.l		er0
		rte

_IntEntry0x6c:
		subs		#2, sp
		stc.w		ccr, @-er7
		push.l		er0
		push.l		er1
		mov.l		@CurrentVector, er0
		mov.b		#0x6c, r0l
		mov.l		@er0, er1
		beq		IntError:16
		mov.w		r1, @(10, sp)
		mov.w		e1, r1
		mov.b		r1l, @(9, sp)
		pop.l		er1
		pop.l		er0
		rte

_IntEntry0x70:
		subs		#2, sp
		stc.w		ccr, @-er7
		push.l		er0
		push.l		er1
		mov.l		@CurrentVector, er0
		mov.b		#0x70, r0l
		mov.l		@er0, er1
		beq		IntError:16
		mov.w		r1, @(10, sp)
		mov.w		e1, r1
		mov.b		r1l, @(9, sp)
		pop.l		er1
		pop.l		er0
		rte

_IntEntry0x74:
		subs		#2, sp
		stc.w		ccr, @-er7
		push.l		er0
		push.l		er1
		mov.l		@CurrentVector, er0
		mov.b		#0x74, r0l
		mov.l		@er0, er1
		beq		IntError:16
		mov.w		r1, @(10, sp)
		mov.w		e1, r1
		mov.b		r1l, @(9, sp)
		pop.l		er1
		pop.l		er0
		rte

_IntEntry0x78:
		subs		#2, sp
		stc.w		ccr, @-er7
		push.l		er0
		push.l		er1
		mov.l		@CurrentVector, er0
		mov.b		#0x78, r0l
		mov.l		@er0, er1
		beq		IntError:16
		mov.w		r1, @(10, sp)
		mov.w		e1, r1
		mov.b		r1l, @(9, sp)
		pop.l		er1
		pop.l		er0
		rte

_IntEntry0x7c:
		subs		#2, sp
		stc.w		ccr, @-er7
		push.l		er0
		push.l		er1
		mov.l		@CurrentVector, er0
		mov.b		#0x7c, r0l
		mov.l		@er0, er1
		beq		IntError:16
		mov.w		r1, @(10, sp)
		mov.w		e1, r1
		mov.b		r1l, @(9, sp)
		pop.l		er1
		pop.l		er0
		rte

_IntEntry0x80:
		subs		#2, sp
		stc.w		ccr, @-er7
		push.l		er0
		push.l		er1
		mov.l		@CurrentVector, er0
		mov.b		#0x80, r0l
		mov.l		@er0, er1
		beq		IntError:16
		mov.w		r1, @(10, sp)
		mov.w		e1, r1
		mov.b		r1l, @(9, sp)
		pop.l		er1
		pop.l		er0
		rte

_IntEntry0x84:
		subs		#2, sp
		stc.w		ccr, @-er7
		push.l		er0
		push.l		er1
		mov.l		@CurrentVector, er0
		mov.b		#0x84, r0l
		mov.l		@er0, er1
		beq		IntError:16
		mov.w		r1, @(10, sp)
		mov.w		e1, r1
		mov.b		r1l, @(9, sp)
		pop.l		er1
		pop.l		er0
		rte

_IntEntry0x88:
		subs		#2, sp
		stc.w		ccr, @-er7
		push.l		er0
		push.l		er1
		mov.l		@CurrentVector, er0
		mov.b		#0x88, r0l
		mov.l		@er0, er1
		beq		IntError:16
		mov.w		r1, @(10, sp)
		mov.w		e1, r1
		mov.b		r1l, @(9, sp)
		pop.l		er1
		pop.l		er0
		rte

_IntEntry0x8c:
		subs		#2, sp
		stc.w		ccr, @-er7
		push.l		er0
		push.l		er1
		mov.l		@CurrentVector, er0
		mov.b		#0x8c, r0l
		mov.l		@er0, er1
		beq		IntError:16
		mov.w		r1, @(10, sp)
		mov.w		e1, r1
		mov.b		r1l, @(9, sp)
		pop.l		er1
		pop.l		er0
		rte

_IntEntry0x90:
		subs		#2, sp
		stc.w		ccr, @-er7
		push.l		er0
		push.l		er1
		mov.l		@CurrentVector, er0
		mov.b		#0x90, r0l
		mov.l		@er0, er1
		beq		IntError:16
		mov.w		r1, @(10, sp)
		mov.w		e1, r1
		mov.b		r1l, @(9, sp)
		pop.l		er1
		pop.l		er0
		rte

_IntEntry0x94:
		subs		#2, sp
		stc.w		ccr, @-er7
		push.l		er0
		push.l		er1
		mov.l		@CurrentVector, er0
		mov.b		#0x94, r0l
		mov.l		@er0, er1
		beq		IntError:16
		mov.w		r1, @(10, sp)
		mov.w		e1, r1
		mov.b		r1l, @(9, sp)
		pop.l		er1
		pop.l		er0
		rte

_IntEntry0x98:
		subs		#2, sp
		stc.w		ccr, @-er7
		push.l		er0
		push.l		er1
		mov.l		@CurrentVector, er0
		mov.b		#0x98, r0l
		mov.l		@er0, er1
		beq		IntError:16
		mov.w		r1, @(10, sp)
		mov.w		e1, r1
		mov.b		r1l, @(9, sp)
		pop.l		er1
		pop.l		er0
		rte

_IntEntry0x9c:
		subs		#2, sp
		stc.w		ccr, @-er7
		push.l		er0
		push.l		er1
		mov.l		@CurrentVector, er0
		mov.b		#0x9c, r0l
		mov.l		@er0, er1
		beq		IntError:16
		mov.w		r1, @(10, sp)
		mov.w		e1, r1
		mov.b		r1l, @(9, sp)
		pop.l		er1
		pop.l		er0
		rte

_IntEntry0xa0:
		subs		#2, sp
		stc.w		ccr, @-er7
		push.l		er0
		push.l		er1
		mov.l		@CurrentVector, er0
		mov.b		#0xa0, r0l
		mov.l		@er0, er1
		beq		IntError:16
		mov.w		r1, @(10, sp)
		mov.w		e1, r1
		mov.b		r1l, @(9, sp)
		pop.l		er1
		pop.l		er0
		rte

_IntEntry0xa4:
		subs		#2, sp
		stc.w		ccr, @-er7
		push.l		er0
		push.l		er1
		mov.l		@CurrentVector, er0
		mov.b		#0xa4, r0l
		mov.l		@er0, er1
		beq		IntError:16
		mov.w		r1, @(10, sp)
		mov.w		e1, r1
		mov.b		r1l, @(9, sp)
		pop.l		er1
		pop.l		er0
		rte

_IntEntry0xa8:
		subs		#2, sp
		stc.w		ccr, @-er7
		push.l		er0
		push.l		er1
		mov.l		@CurrentVector, er0
		mov.b		#0xa8, r0l
		mov.l		@er0, er1
		beq		IntError:16
		mov.w		r1, @(10, sp)
		mov.w		e1, r1
		mov.b		r1l, @(9, sp)
		pop.l		er1
		pop.l		er0
		rte

_IntEntry0xac:
		subs		#2, sp
		stc.w		ccr, @-er7
		push.l		er0
		push.l		er1
		mov.l		@CurrentVector, er0
		mov.b		#0xac, r0l
		mov.l		@er0, er1
		beq		IntError:16
		mov.w		r1, @(10, sp)
		mov.w		e1, r1
		mov.b		r1l, @(9, sp)
		pop.l		er1
		pop.l		er0
		rte

_IntEntry0xb0:
		subs		#2, sp
		stc.w		ccr, @-er7
		push.l		er0
		push.l		er1
		mov.l		@CurrentVector, er0
		mov.b		#0xb0, r0l
		mov.l		@er0, er1
		beq		IntError:16
		mov.w		r1, @(10, sp)
		mov.w		e1, r1
		mov.b		r1l, @(9, sp)
		pop.l		er1
		pop.l		er0
		rte

_IntEntry0xb4:
		subs		#2, sp
		stc.w		ccr, @-er7
		push.l		er0
		push.l		er1
		mov.l		@CurrentVector, er0
		mov.b		#0xb4, r0l
		mov.l		@er0, er1
		beq		IntError:16
		mov.w		r1, @(10, sp)
		mov.w		e1, r1
		mov.b		r1l, @(9, sp)
		pop.l		er1
		pop.l		er0
		rte

_IntEntry0xb8:
		subs		#2, sp
		stc.w		ccr, @-er7
		push.l		er0
		push.l		er1
		mov.l		@CurrentVector, er0
		mov.b		#0xb8, r0l
		mov.l		@er0, er1
		beq		IntError:16
		mov.w		r1, @(10, sp)
		mov.w		e1, r1
		mov.b		r1l, @(9, sp)
		pop.l		er1
		pop.l		er0
		rte

_IntEntry0xbc:
		subs		#2, sp
		stc.w		ccr, @-er7
		push.l		er0
		push.l		er1
		mov.l		@CurrentVector, er0
		mov.b		#0xbc, r0l
		mov.l		@er0, er1
		beq		IntError:16
		mov.w		r1, @(10, sp)
		mov.w		e1, r1
		mov.b		r1l, @(9, sp)
		pop.l		er1
		pop.l		er0
		rte

_IntEntry0xc0:
		subs		#2, sp
		stc.w		ccr, @-er7
		push.l		er0
		push.l		er1
		mov.l		@CurrentVector, er0
		mov.b		#0xc0, r0l
		mov.l		@er0, er1
		beq		IntError:16
		mov.w		r1, @(10, sp)
		mov.w		e1, r1
		mov.b		r1l, @(9, sp)
		pop.l		er1
		pop.l		er0
		rte

_IntEntry0xc4:
		subs		#2, sp
		stc.w		ccr, @-er7
		push.l		er0
		push.l		er1
		mov.l		@CurrentVector, er0
		mov.b		#0xc4, r0l
		mov.l		@er0, er1
		beq		IntError:16
		mov.w		r1, @(10, sp)
		mov.w		e1, r1
		mov.b		r1l, @(9, sp)
		pop.l		er1
		pop.l		er0
		rte

_IntEntry0xc8:
		subs		#2, sp
		stc.w		ccr, @-er7
		push.l		er0
		push.l		er1
		mov.l		@CurrentVector, er0
		mov.b		#0xc8, r0l
		mov.l		@er0, er1
		beq		IntError:16
		mov.w		r1, @(10, sp)
		mov.w		e1, r1
		mov.b		r1l, @(9, sp)
		pop.l		er1
		pop.l		er0
		rte

_IntEntry0xcc:
		subs		#2, sp
		stc.w		ccr, @-er7
		push.l		er0
		push.l		er1
		mov.l		@CurrentVector, er0
		mov.b		#0xcc, r0l
		mov.l		@er0, er1
		beq		IntError:16
		mov.w		r1, @(10, sp)
		mov.w		e1, r1
		mov.b		r1l, @(9, sp)
		pop.l		er1
		pop.l		er0
		rte

_IntEntry0xd0:
		subs		#2, sp
		stc.w		ccr, @-er7
		push.l		er0
		push.l		er1
		mov.l		@CurrentVector, er0
		mov.b		#0xd0, r0l
		mov.l		@er0, er1
		beq		IntError:16
		mov.w		r1, @(10, sp)
		mov.w		e1, r1
		mov.b		r1l, @(9, sp)
		pop.l		er1
		pop.l		er0
		rte

_IntEntry0xd4:
		subs		#2, sp
		stc.w		ccr, @-er7
		push.l		er0
		push.l		er1
		mov.l		@CurrentVector, er0
		mov.b		#0xd4, r0l
		mov.l		@er0, er1
		beq		IntError:16
		mov.w		r1, @(10, sp)
		mov.w		e1, r1
		mov.b		r1l, @(9, sp)
		pop.l		er1
		pop.l		er0
		rte

_IntEntry0xd8:
		subs		#2, sp
		stc.w		ccr, @-er7
		push.l		er0
		push.l		er1
		mov.l		@CurrentVector, er0
		mov.b		#0xd8, r0l
		mov.l		@er0, er1
		beq		IntError:16
		mov.w		r1, @(10, sp)
		mov.w		e1, r1
		mov.b		r1l, @(9, sp)
		pop.l		er1
		pop.l		er0
		rte

_IntEntry0xdc:
		subs		#2, sp
		stc.w		ccr, @-er7
		push.l		er0
		push.l		er1
		mov.l		@CurrentVector, er0
		mov.b		#0xdc, r0l
		mov.l		@er0, er1
		beq		IntError:16
		mov.w		r1, @(10, sp)
		mov.w		e1, r1
		mov.b		r1l, @(9, sp)
		pop.l		er1
		pop.l		er0
		rte

_IntEntry0xe0:
		subs		#2, sp
		stc.w		ccr, @-er7
		push.l		er0
		push.l		er1
		mov.l		@CurrentVector, er0
		mov.b		#0xe0, r0l
		mov.l		@er0, er1
		beq		IntError:16
		mov.w		r1, @(10, sp)
		mov.w		e1, r1
		mov.b		r1l, @(9, sp)
		pop.l		er1
		pop.l		er0
		rte

_IntEntry0xe4:
		subs		#2, sp
		stc.w		ccr, @-er7
		push.l		er0
		push.l		er1
		mov.l		@CurrentVector, er0
		mov.b		#0xe4, r0l
		mov.l		@er0, er1
		beq		IntError:16
		mov.w		r1, @(10, sp)
		mov.w		e1, r1
		mov.b		r1l, @(9, sp)
		pop.l		er1
		pop.l		er0
		rte

_IntEntry0xe8:
		subs		#2, sp
		stc.w		ccr, @-er7
		push.l		er0
		push.l		er1
		mov.l		@CurrentVector, er0
		mov.b		#0xe8, r0l
		mov.l		@er0, er1
		beq		IntError:16
		mov.w		r1, @(10, sp)
		mov.w		e1, r1
		mov.b		r1l, @(9, sp)
		pop.l		er1
		pop.l		er0
		rte

_IntEntry0xec:
		subs		#2, sp
		stc.w		ccr, @-er7
		push.l		er0
		push.l		er1
		mov.l		@CurrentVector, er0
		mov.b		#0xec, r0l
		mov.l		@er0, er1
		beq		IntError:16
		mov.w		r1, @(10, sp)
		mov.w		e1, r1
		mov.b		r1l, @(9, sp)
		pop.l		er1
		pop.l		er0
		rte

_IntEntry0xf0:
		subs		#2, sp
		stc.w		ccr, @-er7
		push.l		er0
		push.l		er1
		mov.l		@CurrentVector, er0
		mov.b		#0xf0, r0l
		mov.l		@er0, er1
		beq		IntError:16:16
		mov.w		r1, @(10, sp)
		mov.w		e1, r1
		mov.b		r1l, @(9, sp)
		pop.l		er1
		pop.l		er0
		rte

_IntEntry0xf4:
		subs		#2, sp
		stc.w		ccr, @-er7
		push.l		er0
		push.l		er1
		mov.l		@CurrentVector, er0
		mov.b		#0xf4, r0l
		mov.l		@er0, er1
		beq		IntError:16
		mov.w		r1, @(10, sp)
		mov.w		e1, r1
		mov.b		r1l, @(9, sp)
		pop.l		er1
		pop.l		er0
		rte

_IntEntry0xf8:
		subs		#2, sp
		stc.w		ccr, @-er7
		push.l		er0
		push.l		er1
		mov.l		@CurrentVector, er0
		mov.b		#0xf8, r0l
		mov.l		@er0, er1
		beq		IntError:16
		mov.w		r1, @(10, sp)
		mov.w		e1, r1
		mov.b		r1l, @(9, sp)
		pop.l		er1
		pop.l		er0
		rte

_IntEntry0xfc:
		subs		#2, sp
		stc.w		ccr, @-er7
		push.l		er0
		push.l		er1
		mov.l		@CurrentVector, er0
		mov.b		#0xfc, r0l
		mov.l		@er0, er1
		beq		IntError:16
		mov.w		r1, @(10, sp)
		mov.w		e1, r1
		mov.b		r1l, @(9, sp)
		pop.l		er1
		pop.l		er0
		rte

IntError:
		shlr.b		r0l
		shlr.b		r0l
		bsr		_interror:16

IntError1:
		bra		IntError1


		.text
		.align		2

/*
 *	Ordinary Vector Area
 */

		.section	.vector

		.long		_Main			/*  0, 0x00: reset */
		.long		_IntEntry0x04		/*  1, 0x04: reserved */
		.long		_IntEntry0x08		/*  2, 0x08: reserved */
		.long		_IntEntry0x0c		/*  3, 0x0c: reserved */
		.long		_IntEntry0x10		/*  4, 0x10: reserved */
		.long		_IntEntry0x14		/*  5, 0x14: reserved */
		.long		_IntEntry0x18		/*  6, 0x18: reserved */
		.long		_IntEntry0x1c		/*  7, 0x1c: NMI */
		.long		_IntEntry0x20		/*  8, 0x20: trap */
		.long		_IntEntry0x24		/*  9, 0x24: trap */
		.long		_IntEntry0x28		/* 10, 0x28: trap */
		.long		_IntEntry0x2c		/* 11, 0x2c: trap */
		.long		_IntEntry0x30		/* 12, 0x30: IRQ0 */
		.long		_IntEntry0x34		/* 13, 0x34: IRQ1 */
		.long		_IntEntry0x38		/* 14, 0x38: IRQ2 */
		.long		_IntEntry0x3c		/* 15, 0x3c: IRQ3 */
		.long		_IntEntry0x40		/* 16, 0x40: IRQ4 */
		.long		_IntEntry0x44		/* 17, 0x44: IRQ5 */
		.long		_IntEntry0x48		/* 18, 0x48: reserved */
		.long		_IntEntry0x4c		/* 19, 0x4c: reserved */
		.long		_IntEntry0x50		/* 20, 0x50: WOVI */
		.long		_IntEntry0x54		/* 21, 0x54: CMI */
		.long		_IntEntry0x58		/* 22, 0x58: reserved */
		.long		_IntEntry0x5c		/* 23, 0x5c: ADI or reserved */
		.long		_IntEntry0x60		/* 24, 0x60: IMIA0 */
		.long		_IntEntry0x64		/* 25, 0x64: IMIB0 */
		.long		_IntEntry0x68		/* 26, 0x68: OVI0 */
		.long		_IntEntry0x6c		/* 27, 0x6c: reserved */
		.long		_IntEntry0x70		/* 28, 0x70: IMIA1 */
		.long		_IntEntry0x74		/* 29, 0x74: IMIB1 */
		.long		_IntEntry0x78		/* 30, 0x78: OVI1 */
		.long		_IntEntry0x7c		/* 31, 0x7c: reserved */
		.long		_IntEntry0x80		/* 32, 0x80: IMIA2 */
		.long		_IntEntry0x84		/* 33, 0x84: IMIB2 */
		.long		_IntEntry0x88		/* 34, 0x88: OVI2 */
		.long		_IntEntry0x8c		/* 35, 0x8c: reserved */
		.long		_IntEntry0x90		/* 36, 0x90: CIMIA0 */
		.long		_IntEntry0x94		/* 37, 0x94: CIMIB0 */
		.long		_IntEntry0x98		/* 38, 0x98: CIMIA1/CIMIB1 */
		.long		_IntEntry0x9c		/* 39, 0x9c: TOVI0/TOVI1 */
		.long		_IntEntry0xa0		/* 40, 0xa0: CIMIA2 */
		.long		_IntEntry0xa4		/* 41, 0xa4: CIMIA2 */
		.long		_IntEntry0xa8		/* 42, 0xa8: CIMIA3/CIMIB3 */
		.long		_IntEntry0xac		/* 43, 0xac: TOVI2/TOVI3 */
		.long		_IntEntry0xb0		/* 44, 0xb0: DEND0A */
		.long		_IntEntry0xb4		/* 45, 0xb4: DEND0B */
		.long		_IntEntry0xb8		/* 46, 0xb8: DEND1A */
		.long		_IntEntry0xbc		/* 47, 0xbc: DEND1B */
		.long		_IntEntry0xc0		/* 48, 0xc0: reserved */
		.long		_IntEntry0xc4		/* 49, 0xc4: reserved */
		.long		_IntEntry0xc8		/* 50, 0xc8: reserved */
		.long		_IntEntry0xcc		/* 51, 0xcc: reserved */
		.long		_IntEntry0xd0		/* 52, 0xd0: ERI0 */
		.long		_IntEntry0xd4		/* 53, 0xd4: RXI0 */
		.long		_IntEntry0xd8		/* 54, 0xd8: TXI0 */
		.long		_IntEntry0xec		/* 55, 0xdc: TEI0 */
		.long		_IntEntry0xe0		/* 56, 0xe0: ERI1 */
		.long		_IntEntry0xe4		/* 57, 0xe4: RXI1 */
		.long		_IntEntry0xe8		/* 58, 0xe8: TXI1 */
		.long		_IntEntry0xec		/* 59, 0xec: TEI1 */
		.long		_IntEntry0xf0		/* 60, 0xf0: ERI2 or ADI */
		.long		_IntEntry0xf4		/* 61, 0xf4: RXI2 or reserved */
		.long		_IntEntry0xf8		/* 62, 0xf8: TXI2 or reserved */
		.long		_IntEntry0xfc		/* 63, 0xfc: TEI2 or reserved */


/*
 *	Monitor Vector Area
 */

		.section	.monvec
		.align		4
		.globl		_MonitorVector

_MonitorVector:

		.long		_Main			/*  0, 0x0000: reset */
		.long		0			/*  1, 0x0004: reserved */
		.long		0			/*  2, 0x0008: reserved */
		.long		0			/*  3, 0x000c: reserved */
		.long		0			/*  4, 0x0010: reserved */
		.long		0			/*  5, 0x0014: reserved */
		.long		0			/*  6, 0x0018: reserved */
		.long		0			/*  7, 0x001c: NMI */
		.long		0			/*  8, 0x0020: trap */
		.long		0			/*  9, 0x0024: trap */
		.long		0			/* 10, 0x0028: trap */
		.long		0			/* 11, 0x002c: trap */
		.long		0			/* 12, 0x0030: IRQ0 */
		.long		0			/* 13, 0x0034: IRQ1 */
		.long		0			/* 14, 0x0038: IRQ2 */
		.long		0			/* 15, 0x003c: IRQ3 */
		.long		0			/* 16, 0x0040: IRQ4 */
		.long		0			/* 17, 0x0044: IRQ5 */
		.long		0			/* 18, 0x0048: reserved */
		.long		0			/* 19, 0x004c: reserved */
		.long		0			/* 20, 0x0050: WOVI */
		.long		0			/* 21, 0x0054: CMI */
		.long		0			/* 22, 0x0058: reserved */
		.long		0			/* 23, 0x005c: ADI */
		.long		0			/* 24, 0x0060: IMIA0 */
		.long		0			/* 25, 0x0064: IMIB0 */
		.long		0			/* 26, 0x0068: OVI0 */
		.long		0			/* 27, 0x006c: reserved */
		.long		0			/* 28, 0x0070: IMIA1 */
		.long		0			/* 29, 0x0074: IMIB1 */
		.long		0			/* 30, 0x0078: OVI1 */
		.long		0			/* 31, 0x007c: reserved */
		.long		0			/* 32, 0x0080: IMIA2 */
		.long		0			/* 33, 0x0084: IMIB2 */
		.long		0			/* 34, 0x0088: OVI2 */
		.long		0			/* 35, 0x008c: reserved */
		.long		0			/* 36, 0x0090: CIMIA0 */
		.long		0			/* 37, 0x0094: CIMIB0 */
		.long		0			/* 38, 0x0098: CIMIA1/CIMIB1 */
		.long		0			/* 39, 0x009c: TOVI0/TOVI1 */
		.long		0			/* 40, 0x00a0: CIMIA2 */
		.long		0			/* 41, 0x00a4: CIMIA2 */
		.long		0			/* 42, 0x00a8: CIMIA3/CIMIB3 */
		.long		0			/* 43, 0x00ac: TOVI2/TOVI3 */
		.long		0			/* 44, 0x00b0: DEND0A */
		.long		0			/* 45, 0x00b4: DEND0B */
		.long		0			/* 46, 0x00b8: DEND1A */
		.long		0			/* 47, 0x00bc: DEND1B */
		.long		0			/* 48, 0x00c0: reserved */
		.long		0			/* 49, 0x00c4: reserved */
		.long		0			/* 50, 0x00c8: reserved */
		.long		0			/* 51, 0x00cc: reserved */
		.long		_InterERI0		/* 52, 0x00d0: ERI0 */
		.long		_InterRXI0		/* 53, 0x00d4: RXI0 */
		.long		_InterTXI0		/* 54, 0x00d8: TXI0 */
		.long		_InterTEI0		/* 55, 0x00dc: TEI0 */
		.long		_InterERI1		/* 56, 0x00e0: ERI1 */
		.long		_InterRXI1		/* 57, 0x00e4: RXI1 */
		.long		_InterTXI1		/* 58, 0x00e8: TXI1 */
		.long		_InterTEI1		/* 59, 0x00ec: TEI1 */

#if MAX_SERIAL >= 3

		.long		_InterERI2		/* 60, 0x00f0: ERI2 */
		.long		_InterRXI2		/* 61, 0x00f4: RXI2 */
		.long		_InterTXI2		/* 62, 0x00f8: TXI2 */
		.long		_InterTEI2		/* 63, 0x00fc: TEI2 */

#else	/* of #if MAX_SERIAL >= 3 */

		.long		0			/* 60, 0x00f0: ERI2 */
		.long		0			/* 61, 0x00f4: RXI2 */
		.long		0			/* 62, 0x00f8: TXI2 */
		.long		0			/* 63, 0x00fc: TEI2 */

#endif	/* of #if MAX_SERIAL >= 3 */

/*
 *	H8 Monitor Data
 */

		.section	.bss

CurrentVector:
		.space		4		/* current vector */
ErrorPoint:
		.space		4		/* error point */

/*
 *	User Vectors
 */

		.section	.uservec
		.globl		_UserVector

_UserVector:
		.space		VECTOR_SIZE


		.end
